package Network;

import java.net.*;
import java.io.*;
import java.util.*;
import java.awt.*;
import java.awt.event.*;
import java.util.concurrent.LinkedBlockingQueue;
import javax.swing.JOptionPane;

public class ClientBlueJ implements Connection {

    Socket socket;
    ObjectOutputStream oos;
    OutputStream outStream;
    DataOutputStream outDataStream;
    WatcherFrame watchedProgram;
    String connectionURL;
    private LinkedBlockingQueue<Object> messages;
    public ClientBlueJ(WatcherFrame theWatchedProgram,int width, int height, boolean showInfo)  {

        watchedProgram=theWatchedProgram;

        watchedProgram.init();
        watchedProgram.setSize(width,height);
        watchedProgram.setVisible(true);
        watchedProgram.setConnection(this);

        if (showInfo)
            connectionURL=JOptionPane.showInputDialog("Enter ip address or type enter for localhost");
        if (!showInfo || connectionURL.equals(""))
            connectionURL="localhost";
        Thread messageHandling = new Thread() {
                public void run(){
                    while(true){
                        try{
                            Object message = messages.remove();
                            watchedProgram.receiveUpdate(message);
                            // Do some handling here...
                            System.out.println("Message Received: " + message);
                        }
                        catch(Exception e){ }
                    }
                }
            };

        messageHandling.setDaemon(true);
        messageHandling.start();
        startClient();
    }  // end Server_Basic constructor

    // **************
    public void stopClient(){
        try {
            oos.close();
            socket.close();
        } catch (IOException e1) {
            // TODO Auto-generated catch block
            e1.printStackTrace();
        }
    }

    public void startClient() {
        // TODO Auto-generated method stub

        try {		
            socket = new Socket(connectionURL, 8995);
            oos = new ObjectOutputStream(socket.getOutputStream());
            processUpdate();
        } catch (Exception e) {
            // TODO Auto-generated catch block
            System.out.println("problem with connection to server");		
        }

    }

    public static void main ( String [ ] args )  {
        // Client_Basic server = new Client_Basic ();
        // server.processUpdate();

    }  // end main

    public void sendObject(Object b) {
        // TODO Auto-generated method stub

        try {		
            System.out.println("about to send");
            oos.writeObject(b);
            oos.reset();
            System.out.println("send");
            //oos.flush();
            // oos.close();
        } catch (Exception e) {
            // TODO Auto-generated catch block
            System.out.println("problem with object");
            //e.printStackTrace();
        }

    }

    public void processUpdate(){

        Thread read = new Thread(){
                public void run(){
                    try {
                        System.out.println("Made Connection");
                        //Object o=ois.readObject();
                        ObjectInputStream ois = new ObjectInputStream(socket.getInputStream());
                        Object b;
                        while (true)
                        {
                            b=ois.readObject();
                            watchedProgram.receiveUpdate(b);

                        }
                    }
                    catch(Exception e){ 
                        //e.printStackTrace(); 
                        System.out.println("Disconnected");
                    }

                }
            };
        read.setDaemon(true);
        read.start();

    }
} 
