/* 
 * Test class to practice mouse movement by drawing a circle where the cursor is. 
 * 
 * Jacob Coon
 * 12/2/14 
 */

import java.awt.*; 
import javax.swing.*; 
import java.awt.event.*; 
import java.awt.image.*; 
import Network.*;
public class Pong extends WatcherFrame implements MouseListener, MouseMotionListener,ActionListener,KeyListener,Runnable 
{ 
    int x=0; 
    int ballX;
    int ballY;
    Score score=new Score();
    BufferedImage offScreen; 
    long startTime = System.currentTimeMillis();
    Paddle leftPaddle = new Paddle();
    Paddle rightPaddle = new Paddle();
    Ball ball = new Ball();
    boolean leftPlayer;
    public void receiveUpdate(Object b) {
        System.out.println("received object");        
    }

    public Pong(String side)
    {
        if (side.equals("left"))
            leftPlayer=true;
        else 
            leftPlayer=false;
    }

    public void init() 
    { 
        addMouseListener(this); 
        addMouseMotionListener(this); 
        addKeyListener(this); 
        setFocusable(true); 
        Container screen = getContentPane(); 
        screen.setBackground(Color.white); 
        screen.setLayout (new FlowLayout() );
        leftPaddle.x = 0;
        rightPaddle.x = 485;
        ball.theScore = score;
        leftPaddle.paddleColor = Color.green;
        rightPaddle.paddleColor = Color.blue;

        //JLabel timeLabel = new JLabel ("times dropped");
        //below is for our offscreen buffer image.  Make it as large  
        offScreen = new BufferedImage(500, 500, BufferedImage.TYPE_INT_RGB);    

    } 

    public void paint (Graphics g) 
    { 
        g.drawImage(offScreen,0,0,this);
    } 

    //Update (the method below) gets called every frame  
    public void update() 
    { 

        Graphics g=getGraphics(); 

        Graphics oG=offScreen.getGraphics(); 
        oG.setColor(Color.white);  
        oG.fillRect(0,0,500,500);

        if (leftPlayer==true)
        {
            leftPaddle.move();            
            leftPaddle.draw(oG);
            ball.collide(leftPaddle);
        }
        else
        {
            rightPaddle.move();    
            rightPaddle.draw(oG);
            ball.collide(rightPaddle);
        }

        ball.draw(oG);
        ball.move();
        score.draw(oG);

        if (ballX >= 500 && score.p1Score<5 && score.p2Score<5 || ballX <= 0 && score.p1Score<5 && score.p2Score<5)
        {    
            ball.resetBall();
        }
        else if (score.p1Score>=5)
        {
            Font winner1Font = new Font("Times New Roman", Font.BOLD, 77);
            oG.setFont(winner1Font);
            oG.setColor(Color.green);
            oG.drawString("PLAYER 1", 75,150);
            oG.drawString("WINS!", 160,210);
        }
        else if (score.p2Score>=5)
        {
            Font winner2Font = new Font("Times New Roman", Font.BOLD, 77);
            oG.setFont(winner2Font);
            oG.setColor(Color.blue);
            oG.drawString("PLAYER 2", 75,150);
            oG.drawString("WINS!", 160,210);
        }
        /*Had to draw to separate strings so it would appear on two different lines
         * I personally think it looks better because there isn't as much empty space
         */
        g.drawImage(offScreen,0,0,this);

      
    } 
    //This is the method that will be called if a key is pressed 
    //It is neccessary if you are using getKeyCode() 
    public void keyPressed(KeyEvent e) 
    { 
        char theChar=e.getKeyChar(); 
        int theCode=e.getKeyCode(); 

        if (theCode == KeyEvent.VK_UP)
        {
            rightPaddle.isMovingUp = true;
        }
        if (theCode == KeyEvent.VK_DOWN)
        {
            rightPaddle.isMovingDown = true;
        }
        if (theCode == KeyEvent.VK_W)
        {
            leftPaddle.isMovingUp = true;
        }
        if (theCode == KeyEvent.VK_S)
        {
            leftPaddle.isMovingDown = true;
        }

    } 

    //This is the method that will be called if a key is released 
    public void keyReleased(KeyEvent e) 
    {   
        char theChar=e.getKeyChar(); 
        int theCode=e.getKeyCode(); 

        if (theCode == KeyEvent.VK_UP)
        {
            rightPaddle.isMovingUp = false;
        }
        if (theCode == KeyEvent.VK_DOWN)
        {
            rightPaddle.isMovingDown = false;
        }
        if (theCode == KeyEvent.VK_W)
        {
            leftPaddle.isMovingUp = false;
        }
        if (theCode == KeyEvent.VK_S)
        {
            leftPaddle.isMovingDown = false;
        }
        //this is for the padddles moving at the same time, if the key's released the paddle shouldn't be moving
    } 

    public void keyTyped(KeyEvent e) 
    {     
    } 

    //when someone presses the mouse button 
    public void mousePressed(MouseEvent e) 
    {      
        int x=e.getX(); 
        int y=e.getY(); 
    } 

    //when someone releases the mouse button 
    public void mouseReleased(MouseEvent e) 
    {      

    } 

    // when the mouse enters the applet 
    public void mouseEntered(MouseEvent e) 
    {      

    } 

    //when the mouse leaves the applet 
    public void mouseExited(MouseEvent e) 
    {      

    } 

    //when the mouse button is clicked 
    public void mouseClicked(MouseEvent e) 
    { 
        requestFocus(); //this bring the focus make to the main progra 

    } 

    //the mouse button is pressed and the mouse makes a significantly large movement 
    public void mouseDragged(MouseEvent e) 
    { 

    } 

    //the mouse makes a significantly large movement 
    public void mouseMoved(MouseEvent e) 
    { 
    } 

    public void actionPerformed(ActionEvent thisEvent) 
    { 
        Object source = thisEvent.getSource(); 

    } 
    public int findRandom (int start, int end) 
    { 
        int multiplier = end-start+1; 
        int random = (int) (Math.random()*multiplier)+start; 
        return random; 
    } 

    public Color findRandomColor () 
    { 
        int red= (int)(256 * Math.random()); 
        int green= (int)(256 * Math.random()); 
        int blue= (int)(256 * Math.random()); 
        Color randomColor=new Color(red,green,blue); 
        return randomColor; 
    }  

    /*********************************************************************************************/
    /* BELOW IS FOR ANIMATION.  THE ONLY THING THAT YOU NEED TO CHANGE IS DELAY */

    int frame; 
    int delay=50;   // this is the time of the delay in milliseconds. 
    Thread animator; 

    /** 
     * This method is called when the applet becomes visible on 
     * the screen. Create a thread and start it. 
     */
    public void start() 
    { 
        animator = new Thread(this); 
        animator.start(); 
    } 

    /** 
     * This method is called by the thread that was created in 
     * the start method. It does the main animation. 
     */
    public void run() 
    { 
        // Remember the starting time 
        long tm = System.currentTimeMillis(); 
        while (Thread.currentThread() == animator) 
        { 
            // Display the next frame of animation. 
            update(); 
            try
            { 
                tm += delay; 
                Thread.sleep(Math.max(0, tm - System.currentTimeMillis())); 
            } 
            catch (InterruptedException e) 
            { 
                break; 
            } 
            // Advance the frame 
            frame++; 
        } 
    } 

    /** 
     * This method is called when the applet is no longer 
     * visible. Set the animator variable to null so that the 
     * thread will exit before displaying the next frame. 
     */
    public void stop() 
    { 
        animator = null; 
    } 

    public static void startServerAndClient() 
    {
        ServerBlueJ s=new ServerBlueJ(2);     //3 is the number of connections allowed    
        new ClientBlueJ(new Pong("left"),500,500,false);
        new ClientBlueJ(new Pong("right"),500,500,false);

    }

    public static void startServer(int connections) {
        ServerBlueJ s=new ServerBlueJ(connections);     
        new ClientBlueJ(new Pong("left"),500,500,false);        
    }

    public static void startClient()
    {
        new ClientBlueJ(new Pong("right"),500,500,false);
    }

} 